FUNCTION vs_progbar, id, percent, Action=action, Title=title
COMMON vs_block

; called with 0,0 a progress bar widget is created and its id returned
; called with id and a percentage greater than zero,  the progress bar 
; is updATED ACCORDINGLY
; CALLED WITH ID AND -1, the widget is terminated

IF total(id) EQ 0 AND percent EQ 0 THEN BEGIN 
    help, calls = a
    caller = strmid(a(1), 0, strpos(a(1), "<")-1)
    IF NOT keyword_set(action) THEN $
      action = 'Doing some complicated thing...'
    IF NOT keyword_set(title) THEN title = caller+' - Progress'
    initbitmap = bytarr(192, 40)
    initbitmap(1, *) = 1
    progress = widget_base(title = title)
    lab = widget_label(progress, value = caller+': '+action, font=vs_fonts[1])
    btn = widget_button(progress, value = cvttobm(initbitmap))
    widget_control, progress, /realize
    return, [progress, btn, lab]
ENDIF 

IF percent LT 0 THEN BEGIN
    widget_control, id[0], /destroy
    return, 0
ENDIF

IF keyword_set(action) THEN widget_control, id[2], set_val=action
bitmap = bytarr(192, 40)
bitmap(0:(percent*1.91-1) > 1, *) = 1
widget_control, id[1], set_value = cvttobm(bitmap)
return, 0
end
